
import os, re, string, socket, xml.sax, xml.sax.handler
import base64
from xml.sax.saxutils import escape
from cStringIO import StringIO

from dbsException import DbsException
from dbsApiException import *

import logging
import inspect

from dbsLogger import *

from dbsUtil import *

def dbsApiImplInsertBranchInfo(self, branchInfo):
    """
    Used to insert BranchHash, alongwith Branch contents and Branch list within this hash 

    params:
	branchHash : md5hash of the Branch, generated by EDM software
	description: a textual (TEXT) description of the set of branches
	content: The XML form of the Branches
	branches: Python list of all branch names included in this BranchHash

    """

    funcInfo = inspect.getframeinfo(inspect.currentframe())
    logging.log(DBSDEBUG, "Api call invoked %s" % str(funcInfo[2]))

    xmlinput  = "<?xml version='1.0' standalone='yes'?>"
    xmlinput += "<dbs>"
    xmlinput += "<branch_info branch_hash='"+branchInfo.get('Hash', '')+"'"
    xmlinput += " content='"+base64.binascii.b2a_base64(branchInfo.get('Content', ''))+"'"
    xmlinput += " description='"+branchInfo.get('Description', '')+"'"
    xmlinput += " >"
    for branch in branchInfo.get('BranchList', []):
        xmlinput += "<branch name='"+branch+"'/>"
    xmlinput += "</branch_info>"
    xmlinput += "</dbs>"

    print xmlinput

    logging.log(DBSDEBUG, xmlinput)
    if self.verbose():
       print "insertBranchInfo:, xmlinput",xmlinput

    data = self._server._call ({ 'api' : 'insertBranchInfo',
                         'xmlinput' : xmlinput }, 'POST')
    logging.log(DBSDEBUG, data)

  # ------------------------------------------------------------

